#!/usr/bin/perl

##############################################################################
# If you encounter problems while trying to configure this script, help      #
# is available.  In order to get your problem solved:                        #
#       1) Read this file thoroughly                                         #
#       2) Consult the THANKS-CGI Frequently Asked Questions:                #
#               http://www.thanks-cgi.com/faq/                               #
#       3) If you are still having difficulty installing this script, send   #
#          e-mail to: webmaster@thanks-cgi.com                               #
#          Include any error messages you are receiving and as much detail   #
#          as you can so we can spot your problem.                           #
#                                                                            #
# Hopefully we will be able to help you solve your problems.  Thank you.     #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 THANKS-CGI All Rights Reserved.                             #
#  Not for re-sell or re-distribution.                                       #
##############################################################################

$searchroot = "/www/yourdomain/search";			# Thr directory of where to start search. You have to set "chmod 777" for it.

$searchrooturl = "http://www.yourdomain.com/search";	# The URL of where to start search.

@searchfiletype = ("*.htm","*.html");			# Define which kind of file you are going to search.

$unix=1;						# If your server is UNIX, please set$unix=1. otherwise set to $unix=0, sucj as NT server.

$resultpage = "/www/yourdomain/search/result.htm";	# The HTML of result screen.

###############
@querys=split(/&/,$ENV{'QUERY_STRING'});
foreach (@querys) {&setv($_);}

read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
@pairs=split(/&/,$buffer);
foreach (@pairs) {&setv($_);}

if ($unix==1) {
   @dir=($searchroot);

   @temp1=@dir; 
   $redo=1;
   while ($redo==1) {
      $redo=0;
      @temp2=();
      foreach (@temp1) {
         chdir($_);
         $temp3 = `ls -l $_`;
         @temp3 = split(/\n/, $temp3);
         @temp4 = ();
         for ($i=0;$i<=$#temp3;$i++) {
             $temp3[$i] =~ s/\s+/ /g;
             ($chkchmod,$chkno,$chkway,$chkowner,$chksize,$chkmonth,$chkday,$chktime,$chkname)=split(/ /,$temp3[$i]);
             if (($chkname) && ($chkchmod =~ /^d/)) {
                push(@temp4,"$_/$chkname");
             }
         } 
         if ($#temp4>=0) {$redo=1;}
         @temp2 = (@temp2,@temp4);
      }   
      @temp1=@temp2;
      @dir=(@dir,@temp2);      
   }

   @files=();
   foreach (@dir) {
      foreach $searchfiletype (@searchfiletype) {
         chdir($_);
         $temp=`ls -l $_/$searchfiletype`;   
         @temp=split(/\n/, $temp);
         for ($i=0;$i<=$#temp;$i++) {
             $temp[$i] =~ s/\s+/ /g;
             ($chkchmod,$chkno,$chkway,$chkowner,$chksize,$chkmonth,$chkday,$chktime,$chkname)=split(/ /,$temp[$i]);
             if (($chkname) && ($chkchmod =~ /^-/)) {
                push(@files,"$chkname");
             }
         }
      }
   }
} else {
   chdir($searchroot);
   $temp = `dir /b/S $searchfiletype[0]`;
   for ($i=1;$i<=$#searchfiletype;$i++) {
       $temp .= `dir /b/S $searchfiletype[$i]`;
   }
   @files = split(/\s+/, $temp);

   foreach (@files) {
      $_ =~ s/\\/\//g;
   } 
}


print "Content-type: text/html\n\n";

@find=();
foreach $file (@files) {
   open(FILE,"$file");
   @lines = <FILE>;
   close(FILE);

   $datas = join(' ',@lines);
   $datas =~ s/\n//g;
   
   if ($datas =~ /$V{'searchword'}/i) {
      push(@find,$file);
   }
}

open(RESULT,"$resultpage");
@result = <RESULT>;
close(RESULT);

foreach (@result) {
   if ($_ =~ /<!--resulthere-->/) {
      if ($#find>=0) {
         print "<b>\n";
         foreach $find (@find) {
            $find =~ s/$searchroot//gi;            
            print "<p><a href=$searchrooturl$find>$searchrooturl$find</a>\n";
         }
         print "</b>\n";
         $match=$#find+1;
         print "<p><i>Find $match document match '<font color=ff0000>$V{'searchword'}</font>' on this web!</i>\n";
      } else {
         print "<p><i>No find document match '<font color=ff0000>$V{'searchword'}</font>' on this web!</i>\n";
      }
   }
   else {
      print;
   }
}
exit 0;
##########
sub setv {
($name,$value)=split(/=/,$_[0]);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/<!--(.|\n)*-->//g;
$value =~ s/\n|\'//g;
if ($V{$name}) {$V{$name}="$V{$name}$value";} else {$V{$name}=$value;}
}
